import matplotlib
matplotlib.use('Agg')

import numpy as np
import matplotlib.pyplot as plt

#from mpl_toolkits.mplot3d import Axes3D # <--- This is important for 3d plotting 

#from matplotlib import cm
#from matplotlib.ticker import LinearLocator

import pandas as pd

import torch
from models import TorchRewardsModel
from datasets import get_dataset
#from algorithms import *
from datasets import SVMDataset, get_dataset, get_batches, GrowingNumpyDataSet, DataSetUnsupervised, DataSet
#from algorithms import get_max_reward_batch, evaluate_rank_observed_reward, get_random_reward_batch

import os

import itertools
import IPython


from one_dim_plotting import plot_dataset_values_one_dim
# import ray

# ray.init()
# USE_RAY = False



dataset_names = ['MultiValleyOneDim', "OneHillValleyOneDim", "MultiValleyOneDimHole", "OneHillValleyOneDimHole"]

for dataset_name in dataset_names:

  info = dict([])
  info["noisy"] = False

  (
    train_dataset,
    _,
    unsupervised_dataset,
  ) = get_dataset(dataset_name, info = info)


  results_folder_name = "line_results/test"

  plot_dir = "./{}".format(results_folder_name)

  if not os.path.isdir(plot_dir):
        os.makedirs(plot_dir)


  all_data_X, all_data_y = get_batches(train_dataset, 1000) 

  plot_dataset_values_one_dim(-10, 10, .01, train_dataset, filename = dataset_name, title = dataset_name, all_dataset = all_data_X, all_queries = [], current_query = [], folder_name = plot_dir)

# all_data_X, all_data_y = get_batches(train_dataset, 32) 

# plot_dataset_values_one_dim(-10, 10, .01, train_dataset, filename = "test_dataset_image1", all_dataset = all_data_X, all_queries = [], current_query = [], folder_name = plot_dir)

#IPython.embed()


